{% extends "default.html" %}
{% load static %}
{% load django_bootstrap5 panel_helpers %}
{% block header %}
<script type="text/javascript" src="{% static 'django_ajax/js/jquery.ajax.min.js' %}"></script>
<script type="text/javascript" src="{% static 'django_ajax/js/jquery.ajax-plugin.min.js' %}"></script>
{% endblock %}

{% block body %}
<div class="container">
  <nav aria-label="breadcrumb">
    <ol class="breadcrumb add-top-margin">
        <li class="breadcrumb-item">
            <a href="{% url 'panels:index' %}">Panels</a>
        </li>
        <li class="breadcrumb-item active">
            {{ panel.level4title.name }}
        </li>
    </ol>
  </nav>

  {% if not panel.panel.is_public %}
  <div class="alert alert-danger" role="alert">This Panel is marked as {{ panel.panel.status|title }}</div>
  {% endif %}

    {% with signed_off_panel=signed_off %}
    {% if signed_off_panel %}
        <div class="alert alert-info" role="alert"><strong>{% signed_off_panel_message signed_off_panel %}</strong></div>
    {% endif %}
    {% endwith %}

  <div id="banner">
      <h1>
          {% block title %}{{ panel.level4title.name }} (Version {{ panel.major_version}}.{{ panel.minor_version}}){% endblock %}
      </h1>
      <div class="lead" id="panel_metadata">
          {% if panel.level4title.level3title %}
              Level 3: {{ panel.level4title.level3title }}<br />
          {% endif %}
          {% if panel.level4title.level2title %}
              Level 2: {{ panel.level4title.level2title }}<br />
          {% endif %}
          {% if panel.old_panels and panel.old_panels.0 %}
              <br/>Relevant disorders: {{ panel.old_panels|join:", " }}
          {% endif %}
          {% if panel.is_super_panel %}
              <br />This panel contains these {{ panel.child_panels.all|length }} panels:
              {% for child_panel in panel.child_panels.all %}<br /><a href="{% url 'panels:detail' child_panel.panel.pk %}">{{ child_panel }}</a> {% endfor %}
          {% endif %}
          {% if panel.panel.types.all %}
              <br />Panel types: {% for type in panel.panel.types.all %}{{ type.name }}{% if not forloop.last %}, {% endif %}{% endfor %}
          {% endif %}
          {% if signed_off %}
              <br />Latest signed off version: {% signed_off_version panel_id=panel.panel_id major_version=signed_off.major_version minor_version=signed_off.minor_version %} ({{ signed_off.signed_off_date }})
              <br />
              <form action="{% url 'panels:download_old_panel_tsv' panel.panel.id %}" id="header_download_signedoff" method="post">{% csrf_token %}
                  <input type="hidden" value="{{ signed_off.major_version }}.{{ signed_off.minor_version }}" name="panel_version" class="input form-control">
                  <button type="submit" class="add-top-margin add-bottom-margin btn btn-primary">Download Latest Signed-Off Version</button>
              </form>
              {% if signed_off_previous_versions %}Previously signed off versions: {% for major_version, minor_version in signed_off_previous_versions %}{% signed_off_version panel_id=panel.panel_id major_version=major_version minor_version=minor_version %}{% if not forloop.last %}, {% endif %}{% endfor %}{% endif %}
          {% endif %}

          {% if panel.panel.old_pk %}<br />Previous code: {{ panel.panel.old_pk }}{% endif %}
      </div>
  </div>

  <div class="row">
      <div class="col-md-8" id="panel_info">
          {% include "panels/genepanel_info.html" %}
      </div>
      <div class="col-md-4">
          {% if not panel.is_super_panel and contributors %}
              <h3 class="remove-top-margin add-bottom-margin">{{ contributors|length }} reviewer{{ contributors|pluralize }}</h3>
              <ul class="list-group remove-bottom-margin">
              {% for contributor in contributors %}
                  <li class="list-group-item reviewer-detail">
                      <p class="bold">{{ contributor.get_full_name }} ({{contributor.reviewer.affiliation}})</p>
                      <p class="text-muted">
                          Group: {{ contributor.reviewer.group }}<br />
                          Workplace: {{ contributor.reviewer.workplace }}
                          {% if request.user.is_authenticated and request.user.reviewer.is_GEL %}
                              <br /><a href="mailto:{{ contributor.email }}" class="link-muted word-break">{{ contributor.email }}</a>
                          {% endif %}
                      </p>
                  </li>
              {% endfor %}
              </ul>
          {% endif %}
      </div>
  </div>

{% with entities=panel.get_all_entities_extra %}
  <h2 class="add-label-margin add-top-margin">{{ entities|length }} Entities</h2>
  <h3 class="text-muted normal remove-top-margin add-bottom-margin">{{ panel.stats.number_of_evaluated_entities }} reviewed{% if request.user.is_authenticated and request.user.reviewer.is_GEL %}, {{ panel.stats.number_of_ready_entities }} ready{% endif %}, {{ panel.stats.number_of_green_entities }} green</h3>

  <div data-module="sortable-table" data-default-key="entity">
      <div class="table-responsive" data-module="filterable-table">
        {% include "panels/entities_list_table.html" with is_super_panel=panel.is_super_panel %}
      </div>
  </div>
{% endwith %}

  {% if panel.version_comment and panel.major_version %}
     <h2>Major version comments</h2>
      <ul class="list-group remove-bottom-margin">
          <li class="list-group-item">
              <p class="remove-bottom-margin">{{ panel.version_comment|linebreaksbr }}</p>
          </li>
      </ul>
  {% endif %}

  {% if not panel.is_super_panel and request.user.is_authenticated and request.user.reviewer.is_GEL %}
      <h3 class="add-top-margin">Promote to version {{ panel.major_version|add:"1" }}</h3>
      <div class="card card-body bg-light add-bottom-margin">
          <p>Promoting a panel will:</p>
          <ul>
              <li>email all reviewers, thanking them for their contribution</li>
              <li>reset the "ready" flag on all genes</li>
              <li>increase the major version of the panel</li>
          </ul>
          <form action="{% url 'panels:promote' panel.panel.id %}" method="post" class="form add-top-margin">
              {% csrf_token %}
              <fieldset>
                  {% for field in promote_panel_form %}
                      <div class="form-group">
                          {% bootstrap_field field %}
                      </div>
                  {% endfor %}
                  <input type="submit" class="btn btn-info" value="Increase Version">
              </fieldset>
          </form>
      </div>
  {% endif %}

  <h2>Downloads</h2>
  <div class="card card-body bg-light add-bottom-margin">
    <h3 class="remove-top-margin">Download lists</h3>
    <ul>
      <li><a href="{% url 'panels:download_panel_tsv' panel.panel.id '01234' %}">Whole panel</a></li>
      <li><a href="{% url 'panels:download_panel_tsv' panel.panel.id '34' %}">Green list (high evidence)</a></li>
      <li><a href="{% url 'panels:download_panel_tsv' panel.panel.id '234' %}">Green and Amber Genes</a></li>
      <li><a href="{% url 'panels:download_panel_tsv' panel.panel.id '2' %}">Amber Genes</a></li>
      <li><a href="{% url 'panels:download_panel_tsv' panel.panel.id '01' %}">Red list (low evidence)</a></li>
    </ul>
    <h3>Download Version</h3>
      <div class="row">
          <div class="col-md-3">
            <form action="{% url 'panels:download_old_panel_tsv' panel.panel.id %}" method="post">
              {% csrf_token %}
              <div class="input-group">
                <input class="form-control" type="text" value="" placeholder="Panel version, for example 0.1", name="panel_version">
                <button class="btn btn-primary" type="submit" class="btn btn-primary">Download</button>
              </div>
            </form>
        </div>
    {% if signed_off %}
    <div class="col">
        <div class="form-group">
          <div class="inline-group">
              <form class="form" action="{% url 'panels:download_old_panel_tsv' panel.panel.id %}" method="post">{% csrf_token %}
              <input type="hidden" value="{{ signed_off.major_version }}.{{ signed_off.minor_version }}" name="panel_version" class="input form-control">
              <button type="submit" class="btn btn-primary">Download Latest Signed-Off Version</button>
              </form>
          </div>
        </div>
    </div>
    {% endif %}
      </div>
  </div>
</div>
{% endblock %}
